import { ValueObject } from "@/core/common/domain";
import { Result } from "@repo/rdx-utils";
import { z } from "zod";

interface IInvoiceNumberProps {
  value: string;
}

export class InvoiceNumber extends ValueObject<IInvoiceNumberProps> {
  private static readonly MAX_LENGTH = 255;

  protected static validate(value: string) {
    const schema = z
      .string()
      .trim()
      .max(InvoiceNumber.MAX_LENGTH, {
        message: `Name must be at most ${InvoiceNumber.MAX_LENGTH} characters long`,
      });
    return schema.safeParse(value);
  }

  static create(value: string) {
    const valueIsValid = InvoiceNumber.validate(value);

    if (!valueIsValid.success) {
      return Result.fail(new Error(valueIsValid.error.errors[0].message));
    }
    return Result.ok(new InvoiceNumber({ value }));
  }

  getValue(): string {
    return this.props.value;
  }

  toString(): string {
    return this.getValue();
  }

  toPrimitive() {
    return this.getValue();
  }
}
